#pragma rtGlobals=1		// Use modern global access method.
#include "EqualizeScaling"

Function ResultsByCoef(data,coef)
wave data, coef

variable ii, points

make /d/o /n=1 Results
points=numpnts(coef)
for (ii=0;ii<points;ii+=1)

results[ii]={data[coef[ii]]}

endfor

SetScale d,-inf,inf,WaveUnits(data,-1) Results

end

///////////////////////////

Function CoMByCoef(CoM, coef)
wave com, coef
variable ii, points
make /d/o/n=(1,2) CbC
points=numpnts(coef)
for (ii=0;ii<points;ii+=1)

	CbC[ii][0]={CoM[coef[ii]][0]}
	CbC[ii][1]={CoM[coef[ii]][1]}

endfor
SetScale d,-inf,inf,WaveUnits(CoM,-1) CbC

end

///////////////////////////

Function ResultsByCat(data,catWave,category)
wave data, catWave
variable category

variable ii, counter=0, points

points=NumPnts(data)
make /d/o /n=1 Results

for (ii=0;ii<points;ii+=1)

	if(catWave[ii]==category)
		results[counter]={data[ii]}
		counter +=1
	endif


endfor

SetScale d,-inf,inf,WaveUnits(data,-1) Results

end

///////////////////////////

Function CoMByLayer(Positions, CoM, Layers)
wave Positions,CoM, Layers

//Layers = {x0, width(x0), x1, width(x1),...xn, width(xn)}

Variable NumLayers = NumPnts(Layers)
Variable NumTerminals=NumPnts(Positions)
Variable ii, jj, counter

Make /d/o/n=(NumTerminals,2,NumLayers/2) CoMPoP=NaN



For(jj=0;jj<NumLayers;jj+=2)
	counter=0
	For(ii=0;ii<numTerminals;ii+=1)

		If((positions[ii] <= Layers[jj] + (Layers[jj+1]/2)) && (positions[ii] >= Layers[jj] - (Layers[jj+1]/2)))
		
			CoMPoP[counter][0][jj]=CoM[ii][0]
			CoMPoP[counter][1][jj]=CoM[ii][1]
		
			Counter +=1
		endif

	EndFor
EndFor
End

///////////////////////////

Function/Wave PopByCat(Pop,catWave,category)
	wave Pop, catWave
	variable category
	
	variable ii, counter=0, points, traces
	
	points=DimSize(Pop,0)
	traces=DimSize(Pop,1)
	make /d/o /n=(points) Results
	
	for (ii=0;ii<traces;ii+=1)
	
		if(catWave[ii]==category)
			results[][counter]={0}				//adding a new row
			results[][counter]=Pop[p][ii]
			counter +=1
		endif
	
	endfor
	
	CopyScaling(Pop,Results)
	
	Return Results
end

///////////////////////////

Function PopByCoef(Pop,Coef)
wave Pop, Coef


variable ii, points, traces

points=DimSize(Pop,0)
traces=NumPnts(Coef)
 
Duplicate /o pop, Results
Redimension /n=(-1,traces) Results

for (ii=0;ii<traces;ii+=1)

		results[][ii]=Pop[p][Coef[ii]]
		
endfor

end

///////////////////////////

Function/Wave CoMByCat(CoM, CatWave,Category)
	wave com, CatWave
	Variable Category
	
	variable ii, points, num, index
	
	points=DimSize(CatWave,0)
	Duplicate/o CoM CbC
	redimension/n=(1,2) CbC
	
	for(ii=0;ii<points;ii+=1)
		index=CatWave[ii]
		
		if(index==category)
			CbC[num][0]={CoM[ii][0]}
			CbC[num][1]={CoM[ii][1]}
			num+=1
		endif
	
	EndFor
	
	
	return CbC

end

///////////////////////////

Function/wave ROIByCat(ROIWave,CatWave,Category)
	Wave ROIWave, CatWave
	Variable Category

	variable ii, points, num, index
	points=DimSize(CatWave,0)

	Duplicate/o ROIWave ROIbC 
	ROIbC=0
	
	for(ii=0;ii<points;ii+=1)
		index=CatWave[ii]
		
		if(index==category)
			MultiThread ROIbC=SelectNumber(ROIWave[p][q]==-ii-1,ROIbC[p][q],-1)
			num+=1
		endif
	
	EndFor


End